import RPi.GPIO as GPIO
from time import sleep
import subprocess

# Direction pin from controller
DIR = 5
CDIR = 10
# Step pin from controller
STEP = 3
CSTEP = 8
# 0/1 used to signify clockwise or counterclockwise.
CW = 1
CCW = 0

#motor steps
tower_steps = 0
found_row = 0

plant_index = [[4,5,14],[3,6,13],[2,7,12],[1,8,11],[0,9,10]]
rows = len(plant_index) 
columns = len(plant_index[0])

# Setup pin layout on PI
GPIO.setmode(GPIO.BOARD)

# Establish Pins in software
GPIO.setup(DIR, GPIO.OUT)
GPIO.setup(STEP, GPIO.OUT)
GPIO.setup(CDIR, GPIO.OUT)
GPIO.setup(CSTEP, GPIO.OUT)

# Set the first direction you want it to spin
#GPIO.output(DIR, CW)
def Main(index):
        
        #display plant 2D array
        for x in plant_index:  # outer loop  
                for i in x:  # inner loop
                    print(i, end = " ") # print the elements  
                print()

        #get plant index
        # input_index = int(input("Enter plant index: "))
        # print("plant_index",input_index)
        input_index = index

    #navigate plant location

        #live camera on
        #execfile("livestreamng.py")
        #exec(open("livestreamng.py").read())
        

        if (input_index != 0):
            navigation(input_index)
            f = open("steps.txt", "w")
            f.write(str(tower_steps) + " " + str(found_row))
        else:
            f = open("steps.txt", "r")
            c = [int(x) for x in f.read().split()]
            camera_default(c[1])
            tower_default(c[0])
            f = open("steps.txt", "w")
            f.write(str(0) + " " + str(0))

        #navigatige defualt location
        # print("tower_default",tower_steps)
        # print("camera_default",found_row)
        # input_defualt = bool(input("Do you want to stop inspection: "))
        # if input_defualt:
        #         camera_default(found_row)
        #         tower_default(tower_steps)
        # else:
        #         camera_default(found_row)
        #         tower_default(tower_steps)
        
    # Once finished clean everything up



def tower_rotate(x):
        print("Tower Rotate",x)
        GPIO.output(DIR,CW)
        for x in range(x):
            GPIO.output(STEP,GPIO.HIGH)
            sleep(.00005) 
            GPIO.output(STEP,GPIO.LOW)
            sleep(.00005)



def camera_movement(y):
        distance_palnts = 64000 #plant distance
        degrees = (y-1)* distance_palnts 
        print("Camera Location",degrees)
        GPIO.output(CDIR,CW)
        for degrees in range(degrees):
            GPIO.output(CSTEP,GPIO.HIGH)
            sleep(.00005) 
            GPIO.output(CSTEP,GPIO.LOW)
            sleep(.00005)


def tower_default(x):
        print("Tower Rerotate",x)
        GPIO.output(DIR,CCW)
        for x in range(x):
            GPIO.output(STEP,GPIO.HIGH)
            sleep(.00005) 
            GPIO.output(STEP,GPIO.LOW)
            sleep(.00005)


def camera_default(y):
        distance_palnts = 64000 #plant distance
        degrees = (y-1)* distance_palnts 
        print("Camera_defualt",degrees)
        GPIO.output(CDIR,CCW)
        for degrees in range(degrees):
            GPIO.output(CSTEP,GPIO.HIGH)
            sleep(.00005) 
            GPIO.output(CSTEP,GPIO.LOW)
            sleep(.00005)


def navigation(input_index):
 #search and identify respective row and column
    global tower_steps
    global found_row
    flag = False
    for i in range(rows):
          for j in range(columns):
                if plant_index[i][j]==input_index:
                  print("Plant Found!")
                  print('row',5-i)
                  print("column",j+1)
                  found_column = j+1
                  found_row = 5-i
                  #print(found_row)
                #switch case for motor commands    
                  if found_column == 1:
                      tower_steps = 0 
                      tower_rotate(tower_steps)
                      sleep(1.0)
                      camera_movement(found_row)
                  elif found_column == 2:
                      tower_steps = 12200
                      tower_rotate(tower_steps)
                      sleep(1.0)
                      camera_movement(found_row)
                  elif found_column == 3:
                      tower_steps = 24400
                      tower_rotate(tower_steps)
                      sleep(1.0)
                      camera_movement(found_row)
                    
                  flag = True
                  break
    if flag == False:
          print ("Plant Not found!")



if __name__ == "__main__":
    Main()
    print("cleanup")
    GPIO.cleanup()
